#include <cstdio>
#include <cstdlib>
#include <queue>
#include <cmath>
using namespace std;

int N, R;
int x[2100];
int y[2100];
int bestRes;

struct Tocka {
  int id;
  int level;
  Tocka *left, *right;
};

Tocka *root;

inline double pow (double d) {
  return d*d;
}

void insert(int thisId) {
  Tocka *p = root;
  Tocka *q;
  q = new Tocka;
  q->id = thisId;
  q->left = q->right = NULL;

  while (true) {
    if (p->level%2 == 0) {
      // compare x-es
      if (x[thisId] < x[p->id]) {
        // pojdi levo
        if (p->left == NULL) {
          q->level = p->level+1;
          p->left = q;
          break;
        } else p = p->left;
      } else {
        // pojdi desno
        if (p->right == NULL) {
          q->level = p->level+1;
          p->right = q;
          break;
        } else p = p->right;
      }
    } else {
      // compare y-es
      if (y[thisId] < y[p->id]) {
        // pojdi levo
        if (p->left == NULL) {
          q->level = p->level+1;
          p->left = q;
          break;
        } else p = p->left;
      } else {
        // pojdi desno
        if (p->right == NULL) {
          q->level = p->level+1;
          p->right = q;
          break;
        } else p = p->right;
      }
    }
  }
}

int myCnt;
double myX, myY;
double prvix, prviy, drugix, drugiy;

void prestej(Tocka *t, double minx, double maxx, double miny, double maxy) {
  if (t == NULL) return;
  if ((pow(x[t->id] - myX) + pow(y[t->id] - myY)) <= R*R + 0.001) {
    printf("%d, %d\n", x[t->id], y[t->id]);
    myCnt++;
  }
  double midx, midy;
  if (t->level%2 == 0) {
    // x
    midx = x[t->id];
    // desno
    if (drugiy < miny || drugix < midx || prviy > maxy || prvix > maxx) {
    } else prestej(t->right, midx, maxx, miny, maxy);
    // levo
    if (drugiy < miny || drugix < minx || prviy > maxy || prvix > midx) {
    } else prestej(t->left, minx, midx, miny, maxy);
  } else {
    // y
    midy = y[t->id];
    // spodaj
    if (drugiy < miny || drugix < minx || prviy > midy || prvix > maxx) {
    } else prestej(t->left, midx, maxx, miny, midy);
    // zgoraj
    if (drugiy < midy || drugix < minx || prviy > maxy || prvix > maxx) {
    } else prestej(t->right, minx, maxx, midy, maxy);
  }
}

int tCnt = 0;

void test(double dx, double dy) {
  printf("Test %d:\n", ++tCnt);
  myCnt = 0;
  myX = dx;
  myY = dy;
  prvix = myX - R; prviy = myY - R;
  drugix = myX + R; drugiy = myY + R;
  prestej(root, -1000000.0, 1000000.0, -1000000.0, 1000000.0);
  if (myCnt > bestRes) bestRes = myCnt;
}

int main() {
  int i, j;
  
  while (true) {
    bestRes = 0;
    scanf("%d %d\n", &N, &R);
    if (N == 0 && R == 0) break;
    for (i=0; i<N; i++) {
      scanf("%d %d", &x[i], &y[i]);
    }
    root = new Tocka;
    root->level = 0;
    root->id = 0;
    root->left = root->right = NULL;
    for (i=1; i<N; i++)
      insert(i);

    double sx, sy;
    double vx, vy;
    double len;
    double vlen;

    for (i=0; i<N-1; i++)
      for (j=i+1; j<N; j++) {
        sx = (x[j] + x[i]) / 2.0;
        sy = (y[j] + y[i]) / 2.0;
        vy = -(x[j] - x[i]);
        vx = y[j] - y[i];
        vlen = sqrt(pow(vx) + pow(vy));
        vx /= vlen;
        vy /= vlen;
        len = sqrt(R*R - fabs(pow(x[j] - x[i]) + pow(x[j] - x[i])));
        test(sx + vx * len, sy + vy * len);
        test(sx + vx * (-len), sy + vy * (-len));
      }
    printf("It is possible to cover %d points.\n", bestRes);
  }
  return 0;
}
